require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe SecretRecordsController do

  # This should return the minimal set of attributes required to create a valid
  # SecretRecord. As you add validations to SecretRecord, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # SecretRecordsController. Be sure to keep this updated too.
  def valid_session
    {}
  end

  describe "GET index" do
    it "assigns all secret_records as @secret_records" do
      secret_record = SecretRecord.create! valid_attributes
      get :index, {}, valid_session
      assigns(:secret_records).should eq([secret_record])
    end
  end

  describe "GET show" do
    it "assigns the requested secret_record as @secret_record" do
      secret_record = SecretRecord.create! valid_attributes
      get :show, {:id => secret_record.to_param}, valid_session
      assigns(:secret_record).should eq(secret_record)
    end
  end

  describe "GET new" do
    it "assigns a new secret_record as @secret_record" do
      get :new, {}, valid_session
      assigns(:secret_record).should be_a_new(SecretRecord)
    end
  end

  describe "GET edit" do
    it "assigns the requested secret_record as @secret_record" do
      secret_record = SecretRecord.create! valid_attributes
      get :edit, {:id => secret_record.to_param}, valid_session
      assigns(:secret_record).should eq(secret_record)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new SecretRecord" do
        expect {
          post :create, {:secret_record => valid_attributes}, valid_session
        }.to change(SecretRecord, :count).by(1)
      end

      it "assigns a newly created secret_record as @secret_record" do
        post :create, {:secret_record => valid_attributes}, valid_session
        assigns(:secret_record).should be_a(SecretRecord)
        assigns(:secret_record).should be_persisted
      end

      it "redirects to the created secret_record" do
        post :create, {:secret_record => valid_attributes}, valid_session
        response.should redirect_to(SecretRecord.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved secret_record as @secret_record" do
        # Trigger the behavior that occurs when invalid params are submitted
        SecretRecord.any_instance.stub(:save).and_return(false)
        post :create, {:secret_record => {}}, valid_session
        assigns(:secret_record).should be_a_new(SecretRecord)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        SecretRecord.any_instance.stub(:save).and_return(false)
        post :create, {:secret_record => {}}, valid_session
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested secret_record" do
        secret_record = SecretRecord.create! valid_attributes
        # Assuming there are no other secret_records in the database, this
        # specifies that the SecretRecord created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        SecretRecord.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, {:id => secret_record.to_param, :secret_record => {'these' => 'params'}}, valid_session
      end

      it "assigns the requested secret_record as @secret_record" do
        secret_record = SecretRecord.create! valid_attributes
        put :update, {:id => secret_record.to_param, :secret_record => valid_attributes}, valid_session
        assigns(:secret_record).should eq(secret_record)
      end

      it "redirects to the secret_record" do
        secret_record = SecretRecord.create! valid_attributes
        put :update, {:id => secret_record.to_param, :secret_record => valid_attributes}, valid_session
        response.should redirect_to(secret_record)
      end
    end

    describe "with invalid params" do
      it "assigns the secret_record as @secret_record" do
        secret_record = SecretRecord.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        SecretRecord.any_instance.stub(:save).and_return(false)
        put :update, {:id => secret_record.to_param, :secret_record => {}}, valid_session
        assigns(:secret_record).should eq(secret_record)
      end

      it "re-renders the 'edit' template" do
        secret_record = SecretRecord.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        SecretRecord.any_instance.stub(:save).and_return(false)
        put :update, {:id => secret_record.to_param, :secret_record => {}}, valid_session
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested secret_record" do
      secret_record = SecretRecord.create! valid_attributes
      expect {
        delete :destroy, {:id => secret_record.to_param}, valid_session
      }.to change(SecretRecord, :count).by(-1)
    end

    it "redirects to the secret_records list" do
      secret_record = SecretRecord.create! valid_attributes
      delete :destroy, {:id => secret_record.to_param}, valid_session
      response.should redirect_to(secret_records_url)
    end
  end

end
